﻿// increase the default animation speed to exaggerate the effect
$.fx.speeds._default = 500;

// Aby se kontrolovaly i ostatni prvky v hidden tabech, defaultne se totiz od verze jQuery.Validation.1.9 ignoruji (https://github.com/jzaefferer/jquery-validation/issues/279)
$.validator.setDefaults({
    ignore: [],
});

$(document).ready(function () {
    $('#myTabs a').click(function (e) {
        e.preventDefault();
        $(this).tab('show');
    });

    //automaticky prepne na tab s chybou
    $("#formService").bind("invalid-form.validate", function (error, validator) {
        if (validator.errorList.length > 0) {
            var tab = $(validator.errorList[0].element).closest('div.tab-pane:not(.active)');

            if (tab) { //pokud existuje neaktivni tab, na kterem validator oznacil nevalidni prvek
                var id = $(tab).attr("id");
                $('#formService a[href="#' + id + '"][role="tab"]').tab('show');
            }
        }
    });

    // ------------------ Eventa pro select2 s uzivateli
    var ddlOperatorsSelectors = '#ddlOperatorsIncidentManagers, #ddlOperatorsIncident1stLineSupport, #ddlOperatorsIncident1stLineSupportReadOnlyMode, #ddlOperatorsIncident2ndLineSupport, ' +
        '#ddlOperatorsServiceRequestManagers, #ddlOperatorsServiceRequest, #ddlOperatorsServiceRequestReadOnlyMode, #ddlOperatorsServiceRequest2ndLineSupport, ' +
        '#ddlOperatorsProblemManagers, #ddlOperatorsProblem, ' +
        '#ddlOperatorsChangeManagers, #ddlOperatorsChange';

    $(ddlOperatorsSelectors).on('select2:select', function (e) { //kdyz vyberu v select2 polozku nactenou ajaxem, tak se propisi atributy do originalniho option, ze ktereho se tvori seznam uzivatelu
        var $option = $(this).find('option[value="' + e.params.data.id + '"]');
        $option.data('is-approved', e.params.data.isApproved);
        $option.data('anonymized', e.params.data.anonymized);
        $option.data('initials', e.params.data.initials);
        $option.data('avatar-color', e.params.data.avatarColor);
        $option.data('has-photo', e.params.data.hasPhoto);
        $option.data('photo-url-hash', e.params.data.photoUrlHash);
    });


    // --------------------- General --------------------------------------------------------------------

    $('.spinner-days').spinner({ min: 0, max: 9999 });
    $('.spinner-days[data-disabled="True"]').spinner({ disabled: true });

    $('.cb-allow-reactivate').change(function () {
        $(this).parent().find('.spinner-days').spinner({
            disabled: !$(this).is(':checked')
        });
    });

    $('.allowDeadline').change(function () {
        SetChangeDeadline($(this));
    });

    //init
    $('.allowDeadline').each(function () {
        SetChangeDeadline($(this));
    });

    function SetChangeDeadline(cbChangeDeadline) {
        var allowChangeDeadline = cbChangeDeadline.parent().next().find('.allowChangeDeadline');
        var checked = cbChangeDeadline.is(':checked');
        allowChangeDeadline.prop('disabled', !checked);

        if (!checked) {
            allowChangeDeadline.prop('checked', false);
        }
    }

    $('.cb-enable-inventory').change(function () {
        var enabled = $(this).is(':checked');
        $(this).parent().find('input[type="radio"]').prop('disabled', !enabled);

        if (!enabled) {
            $(this).parent().find('.label-for-radio').addClass('disabled');
            $(this).nextAll().find('input,select').prop('disabled', true);
        }
        else {
            $(this).parent().find('.label-for-radio').removeClass('disabled');
            $(this).nextAll().find('input,select').prop('disabled', false);
        }
    });





    // --------------------- Incident Management TAB ---------------------------------------------------

    $("#dialog-addremoveOperatorsIncidentManagers").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorsIncidentManagersList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsIncidentManagers").click(function () {
        $("#dialog-addremoveOperatorsIncidentManagers").dialog("open");
        return false;
    });

    function MakeOperatorsIncidentManagersList() {
        $("#divOperatorsIncidentManagers").next(".valid-error").toggle(!$("#ddlOperatorsIncidentManagers option:selected").length);
        var t = MakeUsersList("#ddlOperatorsIncidentManagers", "small");
        $("#divOperatorsIncidentManagers").html(t);
    }

    MakeOperatorsIncidentManagersList(); //init

    $("input[type='radio'][name='Incident1stLineSupportLimitedAccess']").change(function () {
        if ($(this).val() == "True") {
            $("#divIncident1stLineSupportLimitedAccess").show('fast');
        } else {
            $("#divIncident1stLineSupportLimitedAccess").hide('fast');
        }
    });

    $("input[type='radio'][name='IncidentReadOnlyAccessMode']").change(function () {
        if ($(this).val() == "Listed") {
            $("#divIncident1stLineSupportLimitedAccessReadOnlyMode").show('fast');
        } else {
            $("#divIncident1stLineSupportLimitedAccessReadOnlyMode").hide('fast');
        }
    });

    $("#dialog-addremoveOperatorGroupsIncident1stLineSupport").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsIncident1stLineSupportList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorGroupsIncident1stLineSupport").click(function () {
        $("#dialog-addremoveOperatorGroupsIncident1stLineSupport").dialog("open");
        return false;
    });

    function MakeOperatorGroupsIncident1stLineSupportList() {
        var t = '';

        $("#dialog-addremoveOperatorGroupsIncident1stLineSupport input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveOperatorsIncident1stLineSupport").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsIncident1stLineSupportList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsIncident1stLineSupport").click(function () {
        $("#dialog-addremoveOperatorsIncident1stLineSupport").dialog("open");
        return false;
    });

    function MakeOperatorsIncident1stLineSupportList() {
        return MakeUsersList("#ddlOperatorsIncident1stLineSupport", "smaller");
    }

    function MakeOperatorGroupsAndOperatorsIncident1stLineSupportList() {
        var t = MakeOperatorGroupsIncident1stLineSupportList() + MakeOperatorsIncident1stLineSupportList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divOperatorGroupsAndOperatorsIncident1stLineSupport").html(t);
    }

    MakeOperatorGroupsAndOperatorsIncident1stLineSupportList(); //init


    //----- readonly mode list -----

    $("#dialog-addremoveOperatorGroupsIncident1stLineSupportReadOnlyMode").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsIncident1stLineSupportReadOnlyModeList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorGroupsIncident1stLineSupportReadOnlyMode").click(function () {
        $("#dialog-addremoveOperatorGroupsIncident1stLineSupportReadOnlyMode").dialog("open");
        return false;
    });

    function MakeOperatorGroupsIncident1stLineSupportReadOnlyModeList() {
        var t = '';

        $("#dialog-addremoveOperatorGroupsIncident1stLineSupportReadOnlyMode input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveOperatorsIncident1stLineSupportReadOnlyMode").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsIncident1stLineSupportReadOnlyModeList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsIncident1stLineSupportReadOnlyMode").click(function () {
        $("#dialog-addremoveOperatorsIncident1stLineSupportReadOnlyMode").dialog("open");
        return false;
    });


    function MakeOperatorsIncident1stLineSupportReadOnlyModeList() {
        return MakeUsersList("#ddlOperatorsIncident1stLineSupportReadOnlyMode", "smaller");
    }

    function MakeOperatorGroupsAndOperatorsIncident1stLineSupportReadOnlyModeList() {
        var t = MakeOperatorGroupsIncident1stLineSupportReadOnlyModeList() + MakeOperatorsIncident1stLineSupportReadOnlyModeList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divOperatorGroupsAndOperatorsIncident1stLineSupportReadOnlyMode").html(t);
    }

    MakeOperatorGroupsAndOperatorsIncident1stLineSupportReadOnlyModeList(); //init

    // ---------- 2nd -----------

    $("#cbIncidentEnableEscalation").click(function () {
        $(".incident-second-line-support").toggle($(this).is(':checked'));
    });

    $("input[type='radio'][name='Incident2ndLineSupportLimitedAccess']").change(function () {
        if ($(this).val() == "True") {
            $("#divIncident2ndLineSupportLimitedAccess").show('fast');
        } else {
            $("#divIncident2ndLineSupportLimitedAccess").hide('fast');
        }
    });


    //init

    $("#dialog-addremoveOperatorGroupsIncident2ndLineSupport").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsIncident2ndLineSupportList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorGroupsIncident2ndLineSupport").click(function () {
        $("#dialog-addremoveOperatorGroupsIncident2ndLineSupport").dialog("open");
        return false;
    });

    function MakeOperatorGroupsIncident2ndLineSupportList() {
        var t = '';

        $("#dialog-addremoveOperatorGroupsIncident2ndLineSupport input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveOperatorsIncident2ndLineSupport").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsIncident2ndLineSupportList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsIncident2ndLineSupport").click(function () {
        $("#dialog-addremoveOperatorsIncident2ndLineSupport").dialog("open");
        return false;
    });

    function MakeOperatorsIncident2ndLineSupportList() {
        return MakeUsersList("#ddlOperatorsIncident2ndLineSupport", "smaller");
    }

    function MakeOperatorGroupsAndOperatorsIncident2ndLineSupportList() {
        var t = MakeOperatorGroupsIncident2ndLineSupportList() + MakeOperatorsIncident2ndLineSupportList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divOperatorGroupsAndOperatorsIncident2ndLineSupport").html(t);
    }

    MakeOperatorGroupsAndOperatorsIncident2ndLineSupportList(); //init

    // --------- others ------------


    $("#dialogIncidentWorkflow").dialog({
        autoOpen: false,
        resizable: false,
        width: 856,
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    $(this).dialog("close");
                }
            }]
    });

    $("#aIncidentWorkflowDialog").click(function () {
        $("#dialogIncidentWorkflow").dialog("open");
        return false;
    });

    // --------------------- Workflow diagram --------------------------------------------------------
    $("#cbWfDisableIncidentAssignedState").change(function () {

        $("#actionIncidentConfirmAssigning").addClass("hidden");
        $("#actionIncidentConfirmAssigningNoAssignedState").addClass("hidden");
        $("#actionIncidentConfirmAssigningNoConfirmedState").addClass("hidden");
        $("#actionIncidentConfirmAssigningNoAssignedStateNoConfirmedState").addClass("hidden");

        if (this.checked) {
            $(".WfDisableIncidentAssignedState").addClass("hidden");

            if ($("#cbWfDisableIncidentConfirmedState").prop('checked')) {
                $("#actionIncidentConfirmAssigningNoAssignedStateNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionIncidentConfirmAssigningNoAssignedState").removeClass("hidden");
            }
        }
        else {
            $(".WfDisableIncidentAssignedState").removeClass("hidden");

            if ($("#cbWfDisableIncidentConfirmedState").prop('checked')) {
                $("#actionIncidentConfirmAssigningNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionIncidentConfirmAssigning").removeClass("hidden");
            }
        }
    });

    $("#cbWfDisableIncidentTakeFromQueueAction").change(function () {
        if (this.checked) {
            $("#actionIncidentTakeFromQueue").addClass("hidden");
            $("#actionIncidentTakeFromQueueNoConfirmedState").addClass("hidden");
        }
        else {
            if ($("#cbWfDisableIncidentConfirmedState").prop('checked')) {
                $("#actionIncidentTakeFromQueue").addClass("hidden");
                $("#actionIncidentTakeFromQueueNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionIncidentTakeFromQueue").removeClass("hidden");
                $("#actionIncidentTakeFromQueueNoConfirmedState").addClass("hidden");
            }
        }
    });

    $("#cbWfDisableIncidentConfirmedState").change(function () {

        $("#actionIncidentTakeFromQueue").addClass("hidden");
        $("#actionIncidentTakeFromQueueNoConfirmedState").addClass("hidden");
        $("#actionIncidentConfirmAssigning").addClass("hidden");
        $("#actionIncidentConfirmAssigningNoAssignedState").addClass("hidden");
        $("#actionIncidentConfirmAssigningNoConfirmedState").addClass("hidden");
        $("#actionIncidentConfirmAssigningNoAssignedStateNoConfirmedState").addClass("hidden");

        if (this.checked) {
            $(".WfDisableIncidentConfirmedState").addClass("hidden");

            if ($("#cbWfDisableIncidentTakeFromQueueAction").prop('checked')) {
            }
            else {
                $("#actionIncidentTakeFromQueueNoConfirmedState").removeClass("hidden");
            }

            if ($("#cbWfDisableIncidentAssignedState").prop('checked')) {
                $("#actionIncidentConfirmAssigningNoAssignedStateNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionIncidentConfirmAssigningNoConfirmedState").removeClass("hidden");
            }
        }
        else {
            $(".WfDisableIncidentConfirmedState").removeClass("hidden");

            if ($("#cbWfDisableIncidentTakeFromQueueAction").prop('checked')) {
            }
            else {
                $("#actionIncidentTakeFromQueue").removeClass("hidden");
            }

            if ($("#cbWfDisableIncidentAssignedState").prop('checked')) {
                $("#actionIncidentConfirmAssigningNoAssignedState").removeClass("hidden");
            }
            else {
                $("#actionIncidentConfirmAssigning").removeClass("hidden");
            }
        }
    });

    $("#cbWfDisableIncidentFinishSolutionAction").change(function () {
        if (this.checked) {
            $(".WfDisableIncidentFinishSolutionAction").addClass("hidden");
            $("#actionIncidentIncidentFinishSolutionAndCloseFromSuspendedNoConfirmedState").removeClass("hidden");

            $(".WfDisableIncidentAcceptedState").addClass("hidden");
            $("#actionIncidentConfirmAssigningNoAcceptedState").addClass("hidden");
        }
        else {
            $("#actionIncidentIncidentFinishSolutionAndCloseFromSuspendedNoConfirmedState").addClass("hidden");
            $(".WfDisableIncidentFinishSolutionAction").removeClass("hidden");

            if ($("#cbWfDisableIncidentAcceptedState").is(":checked")) {
                $(".WfDisableIncidentAcceptedState").addClass("hidden");
                $("#actionIncidentConfirmAssigningNoAcceptedState").removeClass("hidden");
            }
            else {
                $(".WfDisableIncidentAcceptedState").removeClass("hidden");
                $("#actionIncidentConfirmAssigningNoAcceptedState").addClass("hidden");
            }
        }
    });

    $("#cbWfDisableIncidentCompletedState").change(function () {
        if (this.checked) {
            $(".WfDisableIncidentCompletedState").addClass("hidden");
            $("#actionIncidentComplete").removeClass("hidden");
        }
        else {
            $(".WfDisableIncidentCompletedState").removeClass("hidden");
            $("#actionIncidentComplete").addClass("hidden");
        }
    });

    $("#cbWfDisableIncidentPostponeAction").change(function () {
        if (this.checked) {
            $(".WfDisableIncidentPostponeAction").addClass("hidden");
        }
        else {
            $(".WfDisableIncidentPostponeAction").removeClass("hidden");
        }
    });

    $("#cbWfDoIncidentCompleteActionBySubmittersMessage").change(function () {
        if (this.checked) {
            $(".WfDoIncidentCompleteActionBySubmittersMessage").addClass("dashed");
        }
        else {
            $(".WfDoIncidentCompleteActionBySubmittersMessage").removeClass("dashed");
        }
    });

    $("#cbWfDoIncidentCancelPostponementActionBySubmittersMessage").change(function () {
        if (this.checked) {
            $(".WfDoIncidentCancelPostponementActionBySubmittersMessage").addClass("dashed");
        }
        else {
            $(".WfDoIncidentCancelPostponementActionBySubmittersMessage").removeClass("dashed");
        }
    });

    $("#cbWfDisableIncidentAcceptedState").change(function () {
        if ($("#cbWfDisableIncidentFinishSolutionAction").is(":checked"))
            return;

        if (this.checked) {
            $(".WfDisableIncidentAcceptedState").addClass("hidden");
            $("#actionIncidentConfirmAssigningNoAcceptedState").removeClass("hidden");
        }
        else {
            $(".WfDisableIncidentAcceptedState").removeClass("hidden");
            $("#actionIncidentConfirmAssigningNoAcceptedState").addClass("hidden");
        }
    });

    // --------------------- Request Fulfilment TAB ---------------------------------------------------

    $("#dialog-addremoveOperatorsServiceRequestManagers").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorsServiceRequestManagersList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsServiceRequestManagers").click(function () {
        $("#dialog-addremoveOperatorsServiceRequestManagers").dialog("open");
        return false;
    });

    function MakeOperatorsServiceRequestManagersList() {
        $("#divOperatorsServiceRequestManagers").next(".valid-error").toggle(!$("#ddlOperatorsServiceRequestManagers option:selected").length);
        var t = MakeUsersList("#ddlOperatorsServiceRequestManagers", "small");
        $("#divOperatorsServiceRequestManagers").html(t);
    }

    MakeOperatorsServiceRequestManagersList(); //init

    $("input[type='radio'][name='ServiceRequest1stLineSupportLimitedAccess']").change(function () {
        if ($(this).val() == "True") {
            $("#divServiceRequest1stLineSupportLimitedAccess").show('fast');
        } else {
            $("#divServiceRequest1stLineSupportLimitedAccess").hide('fast');
        }
    });

    $("input[type='radio'][name='ServiceRequestReadOnlyAccessMode']").change(function () {
        if ($(this).val() == "Listed") {
            $("#divServiceRequest1stLineSupportLimitedAccessReadOnlyMode").show('fast');
        } else {
            $("#divServiceRequest1stLineSupportLimitedAccessReadOnlyMode").hide('fast');
        }
    });


    $("#dialog-addremoveOperatorGroupsServiceRequest").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeServiceRequestOperatorGroupsAndOperatorsList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aaddremoveOperatorGroupsServiceRequest").click(function () {
        $("#dialog-addremoveOperatorGroupsServiceRequest").dialog("open");
        return false;
    });

    function MakeServiceRequestOperatorGroupsList() {
        var t = '';

        $("#dialog-addremoveOperatorGroupsServiceRequest input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveOperatorsServiceRequest").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeServiceRequestOperatorGroupsAndOperatorsList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aaddremoveOperatorsServiceRequest").click(function () {
        $("#dialog-addremoveOperatorsServiceRequest").dialog("open");
        return false;
    });

    function MakeServiceRequestOperatorsList() {
        return MakeUsersList("#ddlOperatorsServiceRequest", "smaller");
    }

    function MakeServiceRequestOperatorGroupsAndOperatorsList() {
        var t = MakeServiceRequestOperatorGroupsList() + MakeServiceRequestOperatorsList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divServiceRequestOperatorGroupsAndOperators").html(t);
    }

    MakeServiceRequestOperatorGroupsAndOperatorsList(); //init


    //----- readonly mode list -----

    $("#dialog-addremoveOperatorGroupsServiceRequestReadOnlyMode").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsServiceRequestReadOnlyModeList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorGroupsServiceRequestReadOnlyMode").click(function () {
        $("#dialog-addremoveOperatorGroupsServiceRequestReadOnlyMode").dialog("open");
        return false;
    });

    function MakeOperatorGroupsServiceRequestReadOnlyModeList() {
        var t = '';

        $("#dialog-addremoveOperatorGroupsServiceRequestReadOnlyMode input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveOperatorsServiceRequestReadOnlyMode").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsServiceRequestReadOnlyModeList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsServiceRequestReadOnlyMode").click(function () {
        $("#dialog-addremoveOperatorsServiceRequestReadOnlyMode").dialog("open");
        return false;
    });


    function MakeOperatorsServiceRequestReadOnlyModeList() {
        return MakeUsersList("#ddlOperatorsServiceRequestReadOnlyMode", "smaller");
    }

    function MakeOperatorGroupsAndOperatorsServiceRequestReadOnlyModeList() {
        var t = MakeOperatorGroupsServiceRequestReadOnlyModeList() + MakeOperatorsServiceRequestReadOnlyModeList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divOperatorGroupsAndOperatorsServiceRequestReadOnlyMode").html(t);
    }

    MakeOperatorGroupsAndOperatorsServiceRequestReadOnlyModeList(); //init

    // ---------- 2nd -----------

    $("#cbServiceRequestEnableEscalation").click(function () {
        $(".serviceRequest-second-line-support").toggle($(this).is(':checked'));
    });

    $("input[type='radio'][name='ServiceRequest2ndLineSupportLimitedAccess']").change(function () {
        if ($(this).val() == "True") {
            $("#divServiceRequest2ndLineSupportLimitedAccess").show('fast');
        } else {
            $("#divServiceRequest2ndLineSupportLimitedAccess").hide('fast');
        }
    });

    //init

    $("#dialog-addremoveOperatorGroupsServiceRequest2ndLineSupport").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsServiceRequest2ndLineSupportList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorGroupsServiceRequest2ndLineSupport").click(function () {
        $("#dialog-addremoveOperatorGroupsServiceRequest2ndLineSupport").dialog("open");
        return false;
    });

    function MakeOperatorGroupsServiceRequest2ndLineSupportList() {
        var t = '';

        $("#dialog-addremoveOperatorGroupsServiceRequest2ndLineSupport input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveOperatorsServiceRequest2ndLineSupport").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorGroupsAndOperatorsServiceRequest2ndLineSupportList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsServiceRequest2ndLineSupport").click(function () {
        $("#dialog-addremoveOperatorsServiceRequest2ndLineSupport").dialog("open");
        return false;
    });

    function MakeOperatorsServiceRequest2ndLineSupportList() {
        return MakeUsersList("#ddlOperatorsServiceRequest2ndLineSupport", "smaller");
    }

    function MakeOperatorGroupsAndOperatorsServiceRequest2ndLineSupportList() {
        var t = MakeOperatorGroupsServiceRequest2ndLineSupportList() + MakeOperatorsServiceRequest2ndLineSupportList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divOperatorGroupsAndOperatorsServiceRequest2ndLineSupport").html(t);
    }

    MakeOperatorGroupsAndOperatorsServiceRequest2ndLineSupportList(); //init

    // --------- others------------

    $("#dialogServiceRequestWorkflow").dialog({
        autoOpen: false,
        resizable: false,
        width: 856,
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    $(this).dialog("close");
                }
            }]
    });

    $("#aServiceRequestWorkflowDialog").click(function () {
        $("#dialogServiceRequestWorkflow").dialog("open");
        return false;
    });

    // --------------------- Workflow diagram --------------------------------------------------------
    $("#cbWfDisableServiceRequestAssignedState").change(function () {

        $("#actionServiceRequestConfirmAssigning").addClass("hidden");
        $("#actionServiceRequestConfirmAssigningNoAssignedState").addClass("hidden");
        $("#actionServiceRequestConfirmAssigningNoConfirmedState").addClass("hidden");
        $("#actionServiceRequestConfirmAssigningNoAssignedStateNoConfirmedState").addClass("hidden");

        if (this.checked) {
            $(".WfDisableServiceRequestAssignedState").addClass("hidden");

            if ($("#cbWfDisableServiceRequestConfirmedState").prop('checked')) {
                $("#actionServiceRequestConfirmAssigningNoAssignedStateNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionServiceRequestConfirmAssigningNoAssignedState").removeClass("hidden");
            }
        }
        else {
            $(".WfDisableServiceRequestAssignedState").removeClass("hidden");

            if ($("#cbWfDisableServiceRequestConfirmedState").prop('checked')) {
                $("#actionServiceRequestConfirmAssigningNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionServiceRequestConfirmAssigning").removeClass("hidden");
            }
        }
    });

    $("#cbWfDisableServiceRequestTakeFromQueueAction").change(function () {
        if (this.checked) {
            $("#actionServiceRequestTakeFromQueue").addClass("hidden");
            $("#actionServiceRequestTakeFromQueueNoConfirmedState").addClass("hidden");
        }
        else {
            if ($("#cbWfDisableServiceRequestConfirmedState").prop('checked')) {
                $("#actionServiceRequestTakeFromQueue").addClass("hidden");
                $("#actionServiceRequestTakeFromQueueNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionServiceRequestTakeFromQueue").removeClass("hidden");
                $("#actionServiceRequestTakeFromQueueNoConfirmedState").addClass("hidden");
            }
        }
    });

    $("#cbWfDisableServiceRequestConfirmedState").change(function () {

        $("#actionServiceRequestTakeFromQueue").addClass("hidden");
        $("#actionServiceRequestTakeFromQueueNoConfirmedState").addClass("hidden");
        $("#actionServiceRequestConfirmAssigning").addClass("hidden");
        $("#actionServiceRequestConfirmAssigningNoAssignedState").addClass("hidden");
        $("#actionServiceRequestConfirmAssigningNoConfirmedState").addClass("hidden");
        $("#actionServiceRequestConfirmAssigningNoAssignedStateNoConfirmedState").addClass("hidden");

        if (this.checked) {
            $(".WfDisableServiceRequestConfirmedState").addClass("hidden");

            if ($("#cbWfDisableServiceRequestTakeFromQueueAction").prop('checked')) {
            }
            else {
                $("#actionServiceRequestTakeFromQueueNoConfirmedState").removeClass("hidden");
            }

            if ($("#cbWfDisableServiceRequestAssignedState").prop('checked')) {
                $("#actionServiceRequestConfirmAssigningNoAssignedStateNoConfirmedState").removeClass("hidden");
            }
            else {
                $("#actionServiceRequestConfirmAssigningNoConfirmedState").removeClass("hidden");
            }
        }
        else {
            $(".WfDisableServiceRequestConfirmedState").removeClass("hidden");

            if ($("#cbWfDisableServiceRequestTakeFromQueueAction").prop('checked')) {
            }
            else {
                $("#actionServiceRequestTakeFromQueue").removeClass("hidden");
            }

            if ($("#cbWfDisableServiceRequestAssignedState").prop('checked')) {
                $("#actionServiceRequestConfirmAssigningNoAssignedState").removeClass("hidden");
            }
            else {
                $("#actionServiceRequestConfirmAssigning").removeClass("hidden");
            }
        }
    });

    $("#cbWfDisableServiceRequestFinishSolutionAction").change(function () {
        if (this.checked) {
            $(".WfDisableServiceRequestFinishSolutionAction").addClass("hidden");
            $("#actionServiceRequestFinishSolutionAndCloseFromSuspendedNoConfirmedState").removeClass("hidden");

            $(".WfDisableServiceRequestAcceptedState").addClass("hidden");
            $("#actionServiceRequestConfirmAssigningNoAcceptedState").addClass("hidden");
        }
        else {
            $("#actionServiceRequestFinishSolutionAndCloseFromSuspendedNoConfirmedState").addClass("hidden");
            $(".WfDisableServiceRequestFinishSolutionAction").removeClass("hidden");

            if ($("#cbWfDisableServiceRequestAcceptedState").is(":checked")) {
                $(".WfDisableServiceRequestAcceptedState").addClass("hidden");
                $("#actionServiceRequestConfirmAssigningNoAcceptedState").removeClass("hidden");
            }
            else {
                $(".WfDisableServiceRequestAcceptedState").removeClass("hidden");
                $("#actionServiceRequestConfirmAssigningNoAcceptedState").addClass("hidden");
            }
        }
    });

    $("#cbWfDisableServiceRequestPostponeAction").change(function () {
        if (this.checked) {
            $(".WfDisableServiceRequestPostponeAction").addClass("hidden");
        }
        else {
            $(".WfDisableServiceRequestPostponeAction").removeClass("hidden");
        }
    });

    $("#cbWfDisableServiceRequestCompletedState").change(function () {
        if (this.checked) {
            $(".WfDisableServiceRequestCompletedState").addClass("hidden");
            $("#actionServiceRequestComplete").removeClass("hidden");
        }
        else {
            $(".WfDisableServiceRequestCompletedState").removeClass("hidden");
            $("#actionServiceRequestComplete").addClass("hidden");
        }
    });

    $("#cbWfDoServiceRequestCompleteActionBySubmittersMessage").change(function () {
        if (this.checked) {
            $(".WfDoServiceRequestCompleteActionBySubmittersMessage").addClass("dashed");
        }
        else {
            $(".WfDoServiceRequestCompleteActionBySubmittersMessage").removeClass("dashed");
        }
    });

    $("#cbWfDoServiceRequestCancelPostponementActionBySubmittersMessage").change(function () {
        if (this.checked) {
            $(".WfDoServiceRequestCancelPostponementActionBySubmittersMessage").addClass("dashed");
        }
        else {
            $(".WfDoServiceRequestCancelPostponementActionBySubmittersMessage").removeClass("dashed");
        }
    });

    $("#cbWfDisableServiceRequestAcceptedState").change(function () {
        if ($("#cbWfDisableServiceRequestFinishSolutionAction").is(":checked"))
            return;

        if (this.checked) {
            $(".WfDisableServiceRequestAcceptedState").addClass("hidden");
            $("#actionServiceRequestConfirmAssigningNoAcceptedState").removeClass("hidden");
        }
        else {
            $(".WfDisableServiceRequestAcceptedState").removeClass("hidden");
            $("#actionServiceRequestConfirmAssigningNoAcceptedState").addClass("hidden");
        }
    });

    // --------------------- Problem Management TAB ---------------------------------------------------

    $("#dialog-addremoveOperatorsProblemManagers").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorsProblemManagersList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsProblemManagers").click(function () {
        $("#dialog-addremoveOperatorsProblemManagers").dialog("open");
        return false;
    });

    function MakeOperatorsProblemManagersList() {
        $("#divOperatorsProblemManagers").next(".valid-error").toggle(!$("#ddlOperatorsProblemManagers option:selected").length);
        var t = MakeUsersList("#ddlOperatorsProblemManagers", "small");
        $("#divOperatorsProblemManagers").html(t);
    }

    MakeOperatorsProblemManagersList(); //init


    $("#cbProblemLimitedAccess").change(function () {
        if (this.checked) {
            $("#divProblemLimitedAccess").show('fast');
        } else {
            $("#divProblemLimitedAccess").hide('fast');
        }
    });

    //init
    if ($("#cbProblemLimitedAccess").prop('checked')) {
        $("#divProblemLimitedAccess").show();
    } else {
        $("#divProblemLimitedAccess").hide();
    }

    $("#dialog-addremoveProblemOperatorGroups").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeProblemOperatorGroupsAndOperatorsList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveProblemOperatorGroups").click(function () {
        $("#dialog-addremoveProblemOperatorGroups").dialog("open");
        return false;
    });

    function MakeProblemOperatorGroupsList() {
        var t = '';

        $("#dialog-addremoveProblemOperatorGroups input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveProblemOperators").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeProblemOperatorGroupsAndOperatorsList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveProblemOperators").click(function () {
        $("#dialog-addremoveProblemOperators").dialog("open");
        return false;
    });

    function MakeProblemOperatorsList() {
        return MakeUsersList("#ddlOperatorsProblem", "smaller");
    }

    function MakeProblemOperatorGroupsAndOperatorsList() {
        var t = MakeProblemOperatorGroupsList() + MakeProblemOperatorsList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divProblemOperatorGroupsAndOperators").html(t);
    }

    MakeProblemOperatorGroupsAndOperatorsList(); //init

    $("#dialogProblemWorkflow").dialog({
        autoOpen: false,
        resizable: false,
        width: 700,
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    $(this).dialog("close");
                }
            }]
    });

    $("#aProblemWorkflowDialog").click(function () {
        $("#dialogProblemWorkflow").dialog("open");
        return false;
    });


    // --------------------- Change Management TAB ---------------------------------------------------

    $("#dialog-addremoveOperatorsChangeManagers").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeOperatorsChangeManagersList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveOperatorsChangeManagers").click(function () {
        $("#dialog-addremoveOperatorsChangeManagers").dialog("open");
        return false;
    });

    function MakeOperatorsChangeManagersList() {
        $("#divOperatorsChangeManagers").next(".valid-error").toggle(!$("#ddlOperatorsChangeManagers option:selected").length);
        var t = MakeUsersList("#ddlOperatorsChangeManagers", "small");
        $("#divOperatorsChangeManagers").html(t);
    }

    MakeOperatorsChangeManagersList(); //init


    $("#cbChangeLimitedAccess").change(function () {
        if (this.checked) {
            $("#divChangeLimitedAccess").show('fast');
        } else {
            $("#divChangeLimitedAccess").hide('fast');
        }
    });

    //init
    if ($("#cbChangeLimitedAccess").prop('checked')) {
        $("#divChangeLimitedAccess").show();
    } else {
        $("#divChangeLimitedAccess").hide();
    }

    $("#dialog-addremoveChangeOperatorGroups").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeChangeOperatorGroupsAndOperatorsList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveChangeOperatorGroups").click(function () {
        $("#dialog-addremoveChangeOperatorGroups").dialog("open");
        return false;
    });

    function MakeChangeOperatorGroupsList() {
        var t = '';

        $("#dialog-addremoveChangeOperatorGroups input:checked").each(function (index, item) {
            var label = $("label[for='" + this.id + "']").html() //find label text for input
            t += '<li>' + label + '</li>';
        });

        if (t.length > 0) {
            t = '<ul class="ulImage ulImageOperatorGroups">' + t + '</ul>';
        }

        return t;
    }

    $("#dialog-addremoveChangeOperators").dialog({
        autoOpen: false,
        resizable: false,
        width: "800px",
        height: "auto",
        modal: true,
        closeOnEscape: false,
        dialogClass: 'no-close',
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    MakeChangeOperatorGroupsAndOperatorsList();
                    $(this).dialog("close");
                }
            }]
    });

    $("#aAddRemoveChangeOperators").click(function () {
        $("#dialog-addremoveChangeOperators").dialog("open");
        return false;
    });

    function MakeChangeOperatorsList() {
        return MakeUsersList("#ddlOperatorsChange", "smaller");
    }

    function MakeChangeOperatorGroupsAndOperatorsList() {
        var t = MakeChangeOperatorGroupsList() + MakeChangeOperatorsList();

        if (t.length == 0) {
            t = '<div class="valid-error margin-top-small">' + LocalResource_NoOneSelected + '</div>';
        }

        $("#divChangeOperatorGroupsAndOperators").html(t);
    }

    MakeChangeOperatorGroupsAndOperatorsList(); //init

    $("#dialogChangeWorkflow").dialog({
        autoOpen: false,
        resizable: false,
        width: 900,
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    $(this).dialog("close");
                }
            }]
    });

    $("#aChangeWorkflowDialog").click(function () {
        $("#dialogChangeWorkflow").dialog("open");
        return false;
    });

    // --------------------- Workflow diagram --------------------------------------------------------
    $("#cbWfDisableChangeTakeFromQueueAction").change(function () {
        if (this.checked) {
            $(".WfDisableChangeTakeFromQueueAction").addClass("hidden");
        }
        else {
            if ($("#cbWfDisableChangeAssignedState").prop('checked') && $("#cbWfDisableChangeStartPreparationAction").prop('checked')) {
                $(".WfDisableChangeTakeFromQueueAction:not(.WfDisableChangeAssignedState):not(.WfDisableChangeStartPreparationAction)").removeClass("hidden");
            }
            else if ($("#cbWfDisableChangeAssignedState").prop('checked')) {
                $(".WfDisableChangeTakeFromQueueAction:not(.WfDisableChangeAssignedState)").removeClass("hidden");
            }
            else {
                $(".WfDisableChangeTakeFromQueueAction:not(.WfDisableChangeAssignedStateAlternative)").removeClass("hidden");
            }
        }
    });

    $("#cbWfDisableChangeAssignedState").change(function () {
        if (this.checked) {
            $(".WfDisableChangeAssignedState").addClass("hidden");

            if ($("#cbWfDisableChangeTakeFromQueueAction").prop('checked') && $("#cbWfDisableChangeStartPreparationAction").prop('checked')) {
                $(".WfDisableChangeAssignedStateAlternative:not(.WfDisableChangeTakeFromQueueAction):not(.WfDisableChangeStartPreparationAction)").removeClass("hidden");
            }
            else if ($("#cbWfDisableChangeTakeFromQueueAction").prop('checked')) {
                $(".WfDisableChangeAssignedStateAlternative:not(.WfDisableChangeTakeFromQueueAction)").removeClass("hidden");
            }
            else {
                if ($("#cbWfDisableChangeStartPreparationAction").prop('checked')) {
                    $(".WfDisableChangeAssignedStateAlternative:not(.WfDisableChangeStartPreparationAction)").removeClass("hidden");
                }
                else {
                    $(".WfDisableChangeAssignedStateAlternative").removeClass("hidden");
                }
            }
        }
        else {
            $(".WfDisableChangeAssignedStateAlternative").addClass("hidden");

            if ($("#cbWfDisableChangeTakeFromQueueAction").prop('checked') && $("#cbWfDisableChangeStartPreparationAction").prop('checked')) {
                $(".WfDisableChangeAssignedState:not(.WfDisableChangeTakeFromQueueAction):not(.WfDisableChangeStartPreparationAction)").removeClass("hidden");
            }
            else if ($("#cbWfDisableChangeTakeFromQueueAction").prop('checked')) {
                $(".WfDisableChangeAssignedState:not(.WfDisableChangeTakeFromQueueAction)").removeClass("hidden");
            }
            else {
                if ($("#cbWfDisableChangeStartPreparationAction").prop('checked')) {
                    $(".WfDisableChangeAssignedState:not(.WfDisableChangeStartPreparationAction)").removeClass("hidden");
                }
                else {
                    $(".WfDisableChangeAssignedState").removeClass("hidden");
                }
            }
        }
    });

    $("#cbWfDisableChangeStartPreparationAction").change(function () {
        if (this.checked) {
            $(".WfDisableChangeStartPreparationAction").addClass("hidden");
        }
        else {
            if ($("#cbWfDisableChangeAssignedState").prop('checked') && $("#cbWfDisableChangeTakeFromQueueAction").prop('checked')) {
                $(".WfDisableChangeStartPreparationAction:not(.WfDisableChangeAssignedState):not(.WfDisableChangeTakeFromQueueAction)").removeClass("hidden");
            }
            else if ($("#cbWfDisableChangeAssignedState").prop('checked')) {
                $(".WfDisableChangeStartPreparationAction:not(.WfDisableChangeAssignedState)").removeClass("hidden");
            }
            else {
                $(".WfDisableChangeStartPreparationAction:not(.WfDisableChangeAssignedStateAlternative)").removeClass("hidden");
            }
        }
    });

    $("#cbWfDisableChangeTestingState").change(function () {
        if (this.checked) {
            $(".WfDisableChangeTestingState").addClass("hidden");
            $(".WfDisableChangeTestFailedState").addClass("hidden");
            $(".WfDisableChangeTestingStateAlternative").removeClass("hidden");
        }
        else {
            $(".WfDisableChangeTestingState").removeClass("hidden");
            $(".WfDisableChangeTestFailedState").removeClass("hidden");
            $(".WfDisableChangeTestingStateAlternative").addClass("hidden");
        }
    });

    // --------------------- Service inheritance

    $("#cbInheritsFromDepartment").change(function () {
        $("#myTabs li:not(#liTabBasics)").toggle(!this.checked);
    });

    // --------------------- Enabling managements

    var toggleOnClass = "fa fa-toggle-on green";
    var toggleOffClass = "fa fa-toggle-off gray";

    $("#cbEnableIncidentManagement").change(function () {
        if (this.checked) {
            $("#divIncidentManagement").slideDown();
            $('#toggleIncidents').attr('class', toggleOnClass);
        }
        else {
            $("#divIncidentManagement").slideUp();
            $('#toggleIncidents').attr('class', toggleOffClass);
        }

    });

    $("#cbEnableRequestFulfilment").change(function () {
        if (this.checked) {
            $("#divRequestFulfilment").slideDown();
            $('#toggleServiceRequests').attr('class', toggleOnClass);
        }
        else {
            $("#divRequestFulfilment").slideUp();
            $('#toggleServiceRequests').attr('class', toggleOffClass);
        }
    });

    $("#cbEnableProblemManagement").change(function () {
        if (this.checked) {
            $("#divProblemManagement").slideDown();
            $('#toggleProblems').attr('class', toggleOnClass);
        }
        else {
            $("#divProblemManagement").slideUp();
            $('#toggleProblems').attr('class', toggleOffClass);
        }
    });

    $("#cbEnableChangeManagement").change(function () {
        if (this.checked) {
            $("#divChangeManagement").slideDown();
            $('#toggleChanges').attr('class', toggleOnClass);
        }
        else {
            $("#divChangeManagement").slideUp();
            $('#toggleChanges').attr('class', toggleOffClass);
        }
    });

    function ValidateForm() {
        var error = false;

        if (AllowIncidents) {
            if ($("#ddlOperatorsIncidentManagers option:selected").length == 0 && $('#cbEnableIncidentManagement').is(':checked')) {
                $('.nav-tabs a[href="#tabIncidents"]').tab('show');
                error = true;
            }
        }

        if (AllowServiceRequests) {
            if ($("#ddlOperatorsServiceRequestManagers option:selected").length == 0 && $('#cbEnableRequestFulfilment').is(':checked')) {
                $('.nav-tabs a[href="#tabServiceRequests"]').tab('show');
                error = true;
            }
        }

        if (AllowProblems) {
            if ($("#ddlOperatorsProblemManagers option:selected").length == 0 && $('#cbEnableProblemManagement').is(':checked')) {
                $('.nav-tabs a[href="#tabProblems"]').tab('show');
                error = true;
            }
        }

        if (AllowChanges) {
            if ($("#ddlOperatorsChangeManagers option:selected").length == 0 && $('#cbEnableChangeManagement').is(':checked')) {
                $('.nav-tabs a[href="#tabChanges"]').tab('show');
                error = true;
            }
        }

        if (!ValidateServiceEmailFromAddressCustomSelection()) {
            error = true;
        }

        if (error) {
            var $container = $("html,body");
            var $scrollTo = $('.valid-error:visible').first();

            $([document.documentElement, document.body]).animate({
                scrollTop: $scrollTo.offset().top
            }, 300);

            return false;
        }

        return true;
    }

    // --------------------- To submit data from dialogs (http://stackoverflow.com/questions/567637/jquery-modal-window-removes-elements-from-my-form)
    $("#formService").submit(function (event) {
        if (ValidateForm() &&
            $('#formService').validate().checkForm()) { // kdyz to neudelam, tak to tam movne i kdyz vyskoci client side chyba a pak to v dialogu bude chybet
            $("#dialog-addremoveOperatorsIncidentManagers").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorGroupsIncident1stLineSupport").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsIncident1stLineSupport").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorGroupsIncident1stLineSupportReadOnlyMode").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsIncident1stLineSupportReadOnlyMode").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorGroupsIncident2ndLineSupport").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsIncident2ndLineSupport").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsServiceRequestManagers").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorGroupsServiceRequest").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsServiceRequest").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorGroupsServiceRequestReadOnlyMode").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsServiceRequestReadOnlyMode").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorGroupsServiceRequest2ndLineSupport").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsServiceRequest2ndLineSupport").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsProblemManagers").prependTo("#beforesubmit");
            $("#dialog-addremoveProblemOperatorGroups").prependTo("#beforesubmit");
            $("#dialog-addremoveProblemOperators").prependTo("#beforesubmit");
            $("#dialog-addremoveOperatorsChangeManagers").prependTo("#beforesubmit");
            $("#dialog-addremoveChangeOperatorGroups").prependTo("#beforesubmit");
            $("#dialog-addremoveChangeOperators").prependTo("#beforesubmit");
            $("#dialogIncidentWorkflow").prependTo("#beforesubmit");
            $("#dialogServiceRequestWorkflow").prependTo("#beforesubmit");
            $("#dialogProblemWorkflow").prependTo("#beforesubmit");
            $("#dialogChangeWorkflow").prependTo("#beforesubmit");
        }
        else
            event.preventDefault();
    });

    function ValidateServiceEmailFromAddressCustomSelection() {
        if ($('input[type="radio"][name="ServiceEmailFromAddressRestriction"]:checked').val() == 'CustomSelection' && $('#ddlServiceEmailFromAddressCustomSelection option:selected').length == 0) {
            $('.nav-tabs a[href="#tabOptions"]').tab('show');
            $('#lbServiceEmailFromAddressCustomSelectionRequired').show();
            return false;
        }
        else {
            $('#lbServiceEmailFromAddressCustomSelectionRequired').hide();
            return true;
        }
    }

}); //end document ready



function MakeUsersList(ddl, size) {
    var t = '';
    var lineHeight = 50;

    if (size == 'small')
        lineHeight = 40;
    else if (size == 'smaller')
        lineHeight = 20;

    if ($(ddl).find("option:selected").length) {
        $(ddl).find("option:selected").each(function () {
            t += '<div style="line-height: ' + lineHeight + 'px; margin: 5px;">' +
                userAvatar($(this).val(), $(this).text(), $(this).data('initials'), $(this).data('avatar-color'), $(this).data('has-photo'), $(this).data('photo-url-hash'), $(this).data('anonymized'), $(this).data('deleted'), size, 'left margin-right-small') +
                '<a href="' + RQ_URL + '/Account/User/' + $(this).val() + '">' + htmlEncode($(this).text()) + '</a>' +
                '</div>';
        });

        t = '<div>' + t + '</div>';
    }

    return t;
}


