﻿$(document).ready(function () {
    $("#dialog-confirm").dialog({
        autoOpen: false,
        modal: true,
        resizable: false
    });

    $("#dialog-tag-rename").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Admin_TicketTags_Change,
            click: function () {
                var value = $("#DialogTagName").val();
                $("#DialogTagNameError").hide();
                if (value == "") {
                    $("#DialogTagNameError").show();
                }
                else {
                    $("#dialog-tag-rename").dialog("close");
                    OnAjaxBegin(Localization_Saving);
                    $.ajax({
                        url: RQ_URL + "/Admin/Tags/ChangeName",
                        type: "POST",
                        data: JSON.stringify({
                            id: $("#DialogTagId").val(),
                            value: value,
                        }),
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function (g) {
                            $("#TableTagEdit" + $("#DialogTagId").val()).attr("data-name", $("#DialogTagName").val());                            
                            $("#TableTagEdit" + $("#DialogTagId").val()).tooltipBS('hide');
                            if (tagType == 1) {
                                $("#jqGrid").trigger("reloadGrid");
                            }
                            else {
                                $("#jqGridCustomer").trigger("reloadGrid");
                            }
                        },
                        error: function (error) { alert(error.responseText); },
                        complete: function () {
                            OnAjaxComplete();
                        }
                    });
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $("#TableTagEdit" + $("#DialogTagId").val()).tooltipBS('hide');
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-tag-new").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Admin_TicketTags_Create,
            click: function () {
                var name = $("#DialogTagNewName").val();
                $("#DialogTagNewNameError").hide();
                $("#DialogTagNewNameExistError").hide();
                if (name == "") {
                    $("#DialogTagNewNameError").show();
                }
                else {
                    $.ajax({
                        url: RQ_URL + "/Admin/Tags/NewTag",
                        type: "POST",
                        data: JSON.stringify({
                            name: name,
                            color: $("#DialogTagNewColor").val(),
                            type: tagType,
                        }),
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function (g) {
                            if (g === true) {
                                $("#dialog-tag-new").dialog("close");
                                if (tagType == 1) {
                                    $("#jqGrid").trigger("reloadGrid");
                                }
                                else {
                                    $("#jqGridCustomer").trigger("reloadGrid");
                                }
                            }
                            else {
                                $("#DialogTagNewNameExistError").show();
                            }
                        },
                        error: function (error) { alert(error.responseText); },
                        complete: function () {
                        }
                    });
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("body").on("change", ".table-color-change .colorSelector-input", function (e) {
        var id = $(this).attr("data-id");
        var color = $(this).val();        
        $.ajax({
            url: RQ_URL + "/Admin/Tags/ChangeColor",
            type: "POST",
            data: JSON.stringify({
                id: id,
                value: color,
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    });

    $("body").on("change", ".ticket-tag-checkbox", function (e) {
        var id = $(this).attr("data-id");
        var checked = $(this).is(":checked");
        $.ajax({
            url: RQ_URL + "/Admin/Tags/ChangeStatic",
            type: "POST",
            data: JSON.stringify({
                id: id,
                value: checked,
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
                OnAjaxComplete();
            }
        });
    });
});

function rename(id) {
    $("#DialogTagId").val(id);
    $("#DialogTagName").val($("#TableTagEdit" + id).attr("data-name"));
    $("#dialog-tag-rename").dialog("open");
}

function newTag() {
    $("#DialogTagNewName").val("");
    $("#DialogTagNewColor").val("#f0f0f0");
    ColorChanged($("#DialogTagNewColor"));
    $("#dialog-tag-new").dialog("open");
}