﻿var dialogUserFieldSettings, dialogUserFieldDelete, deleteId, $elementForDelete;
$(document).ready(function () {
    dialogUserFieldSettings = $("#DialogUserFieldSettings").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Save,
                click: function () {
                    $("#ItemsError").hide();
                    if ($("#UserFieldSettingsCustomFieldType").val() == "DropDown" && $(".user-field-items .user-field-item").length <= 0) {
                        $("#ItemsError").show();
                    }
                    else {
                        SaveSettings();
                    }
                }
            }, {
                text: Localization_Cancel,
                click: function () {
                    dialogUserFieldSettings.dialog("close");
                }
            }]
    });

    dialogUserFieldDelete = $("#DialogUserFieldDelete").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
        [{
            text: Localization_Yes,
            click: function () {
                OnAjaxBegin(Localization_Delete);
                $.ajax({
                    url: RQ_URL + "/Admin/UserFields/Delete",
                    type: "POST",
                    data: JSON.stringify({
                        id: deleteId,
                    }),
                    dataType: "html",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                        $elementForDelete.closest(".user-field").detach();
                        dialogUserFieldDelete.dialog("close");
                        OnAjaxComplete();
                    }
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                dialogUserFieldDelete.dialog("close");                
            }
        }]
    });

    

    $(".draggable").draggable({
        connectToSortable: '#sortable',
        helper: "clone",
        stop: function (event, ui) {
            if ($("#sortable").find(".draggable").length > 0) {
                var position = $("#sortable").find(".draggable").index();
                var type = $("#sortable").find(".draggable").data("type");
                $("#sortable").find(".draggable").html("<div class='loading-32'></div>");
                $.ajax({
                    url: RQ_URL + "/Admin/UserFields/AddType",
                    type: "POST",
                    data: JSON.stringify({
                        type: type,
                        index: position,
                    }),
                    dataType: "html",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                        if (position == 0) {
                            $("#sortable").prepend(g);
                        } else {
                            $("#sortable > div.user-field:nth-child(" + (position) + ")").after(g);
                        }
                        $("#sortable").find(".draggable").detach();
                        initBsTooltip();
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                    }
                });
            }
            initBsTooltip();
        },
    });

    $("#sortable, div.user-field").disableSelection();
    $("#sortable").droppable({
        accept: "div.draggable",
        drop: function (event, ui) {
        },
    }).sortable({
        items: ".user-field",
        handle: ".handle",
        placeholder: "ui-state-highlight-user-field",
        stop: function (event, ui) {
            var ids = $(".user-fields-left-box .content .user-field").map(function () {
                return $(this).data("id");
            }).get();
            $.ajax({
                url: RQ_URL + "/Admin/UserFields/ChangePositions",
                type: "POST",
                data: JSON.stringify({
                    ids: ids
                }),
                dataType: "html",
                contentType: "application/json; charset=utf-8",
                success: function (g) {
                    if (position == 0) {
                        $("#sortable").prepend(g);
                    } else {
                        $("#sortable > div.user-field:nth-child(" + (position) + ")").after(g);
                    }
                    $("#sortable").find(".draggable").detach();
                },
                error: function (error) { alert(error.responseText); },
                complete: function () {
                }
            });
        }
    });

    $(".user-fields-left-box").on("click", ".user-field .fa-cog", function () {
        var id = $(this).closest(".user-field").data("id");
        dialogUserFieldSettings.html("<div class='loading-32'></div>");
        dialogUserFieldSettings.dialog("open");
        $.ajax({
            url: RQ_URL + "/Admin/UserFields/GetSettings",
            type: "POST",
            data: JSON.stringify({
                id: id,
            }),
            dataType: "html",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                dialogUserFieldSettings.html(g);
                initSortableDropDownItems();
                if ($("#UserFieldSettingsCustomFieldType").val() == "DropDown") {
                    if ($("#UserFieldSettingsPleaseSelect").is(":checked")) {
                        $("#UserFieldSettingsRequired").prop("disabled", false);
                    }
                    else {
                        $("#UserFieldSettingsRequired").prop("disabled", true);
                        $("#UserFieldSettingsRequired").prop("checked", false);
                    }
                }
                dialogUserFieldSettings.dialog("close");
                dialogUserFieldSettings.dialog("open");
                initBsTooltip();
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    });

    $(".user-fields-left-box").on("click", ".user-field .fa-trash", function () {
        dialogUserFieldDelete.dialog("open");
        deleteId = $(this).closest(".user-field").data("id");
        $elementForDelete = $(this);
       
    });

    $("#DialogUserFieldSettings").on("change", "#UserFieldSettingsShow", function () {
        if ($(this).is(":checked")) {
            $("#UserFieldSettingsShowInRegistrationForm").prop("disabled", false);
            $("#UserFieldSettingsShowInPublicRegistrationForm").prop("disabled", false);
        }
        else {
            $("#UserFieldSettingsShowInRegistrationForm").prop("disabled", true);
            $("#UserFieldSettingsShowInRegistrationForm").prop("checked", false);
            $("#UserFieldSettingsShowInPublicRegistrationForm").prop("disabled", true);
            $("#UserFieldSettingsShowInPublicRegistrationForm").prop("checked", false);
        }
    });

    $("#DialogUserFieldSettings").on("click", "#UserFieldSettingsPleaseSelect", function () {
        if ($("#UserFieldSettingsCustomFieldType").val() == "DropDown") {
            if ($(this).is(":checked")) {
                $("#UserFieldSettingsRequired").prop("disabled", false); 
            }
            else {
                $("#UserFieldSettingsRequired").prop("disabled", true);
                $("#UserFieldSettingsRequired").prop("checked", false);
            }
        }
    });

    $("#DialogUserFieldSettings").on("click", ".user-field-item .fa-trash-o", function () {
        $(this).closest(".user-field-item").remove();
    });

    $("#DialogUserOperatorRoleBoxSettings").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
        [{
            text: Localization_Ok,
            click: function () {
                $("#DialogUserOperatorRoleBoxSettings").dialog("close");
            }
        }]
    });

    $("#DialogUserSimpleRoleBoxSettings").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Ok,
                click: function () {
                    $("#DialogUserSimpleRoleBoxSettings").dialog("close");
                }
            }]
    });

    $("#DialogUserSimpleRoleBoxSettings").on("change", "#CustomerAndUserFields", function () {
        if ($("#CustomerAndUserFields").val() != null && $("#CustomerAndUserFields").val() != "") {
            addNewUserSimpleRoleBoxField($("#CustomerAndUserFields").val());
            var optionSelected = $("option:selected", this);
            optionSelected.attr("disabled", "disabled");
            $("#CustomerAndUserFields").val(null).trigger("change");
            SearchableCombos();
        }
    });

    $("#DialogUserOperatorRoleBoxSettings").on("change", "#UserFields", function () {
        if ($("#UserFields").val() != null && $("#UserFields").val() != "") {
            addNewUserOperatorRoleBoxField($("#UserFields").val());
            var optionSelected = $("option:selected", this);
            optionSelected.attr("disabled", "disabled");
            $("#UserFields").val(null).trigger("change");
            SearchableCombos();
        }
    });

    $("#DialogUserSimpleRoleBoxSettings").on("click", ".user-simple-role-box-field .fa-trash", function () {
        var id = $(this).closest(".user-simple-role-box-field").data("id");
        var optionSelected = $("#CustomerAndUserFields option[value='" + $(this).closest(".user-simple-role-box-field").data("select2id") + "']");
        optionSelected.removeAttr("disabled");
        SearchableCombos();
        $(this).closest(".user-simple-role-box-field").remove();
        $.ajax({
            url: RQ_URL + '/Admin/UserBoxSettings/Delete',
            data: {
                id: id
            },
            type: "POST"
        });
    });

    $("#DialogUserOperatorRoleBoxSettings").on("click", ".user-operator-role-box-field .fa-trash", function () {
        var id = $(this).closest(".user-operator-role-box-field").data("id");
        var optionSelected = $("#UserFields option[value='" + $(this).closest(".user-operator-role-box-field").data("select2id") + "']");
        optionSelected.removeAttr("disabled");
        SearchableCombos();
        $(this).closest(".user-operator-role-box-field").remove();
        $.ajax({
            url: RQ_URL + '/Admin/UserBoxSettings/Delete',
            data: {
                id: id
            },
            type: "POST"
        });
    });
});

function SaveSettings() {
    OnAjaxBegin(Localization_Saving);
    if ($("#UserFieldSettingsCustomFieldType").val() == "ID" && $("#UserFieldSettingsUnique").is(":checked")) {
        $.ajax({
            url: RQ_URL + "/Admin/UserFields/CheckIsUnique",
            type: "POST",
            data: JSON.stringify({
                Id: $("#UserFieldSettingsId").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                if (g == true) {
                    CallSaveSettings();
                }
                else {
                    OnAjaxComplete();
                    $("#UserFieldSettingsUnique").closest(".form-group").find(".valid-error").show();
                }
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    }
    else {
        CallSaveSettings();
    }
}

function CallSaveSettings() {
    var items = Array();
    $(".user-field-items .user-field-item").each(function (index, value) {
        items.push({
            IsNew: $(value).data("isnew"),
            Id: $(value).data("id"),
            Index: index,
            Title: $(value).find("input[type='text']").val(),
        });
    });

    $.ajax({
        url: RQ_URL + "/Admin/UserFields/SaveSettings",
        type: "POST",
        data: JSON.stringify({
            Id: $("#UserFieldSettingsId").val(),
            CustomFieldTitle: $("#UserFieldSettingsCustomFieldTitle").val(),
            Show: $("#UserFieldSettingsShow").is(":checked"),
            ShowInPublicRegistrationForm: $("#UserFieldSettingsShowInPublicRegistrationForm").is(":checked"),
            ShowInRegistrationForm: $("#UserFieldSettingsShowInRegistrationForm").is(":checked"),
            Required: $("#UserFieldSettingsRequired").is(":checked"),
            HintText: $("#UserFieldSettingsHintText").val(),
            IsUnique: $("#UserFieldSettingsUnique").is(":checked"),
            PleaseSelect: $("#UserFieldSettingsPleaseSelect").is(":checked"),
            MinLength: $("#UserFieldSettingsMinLength").val(),
            MaxLength: $("#UserFieldSettingsMaxLength").val(),
            Items: items
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            var id = $("#UserFieldSettingsId").val();
            $(".user-field[data-id='" + id + "']").after(g);
            $(".user-field[data-id='" + id + "']").first().detach();
            dialogUserFieldSettings.dialog("close");
            initBsTooltip();
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
            OnAjaxComplete();
        }
    });
}

function addNewRow() {
    $(".user-field-items").append("<div class='user-field-item' data-isnew='true'> <i class='fa fa-fw fa-arrows handle'></i><input type='text' /><i class='fa fa-fw fa-trash-o cursor_pointer'></i></div>");
    initSortableDropDownItems();
}

function initSortableDropDownItems() {
    $(".user-field-items").sortable({
        items: ".user-field-item",
        handle: ".handle"
    });
}

function showUserSimpleRoleBoxSettingDialog() {
    $("#DialogUserSimpleRoleBoxSettings").dialog("open");
    $("#DialogUserSimpleRoleBoxSettings").html("<div class='loading-32'></div>");
    $("#DialogUserSimpleRoleBoxSettings").load(RQ_URL + "/Admin/UserBoxSettings/GetUserSimpleRoleBoxSettings", function () {
        $("#DialogUserSimpleRoleBoxSettings").dialog("close");
        $("#DialogUserSimpleRoleBoxSettings").dialog("open");
    });
}

function showUserOperatorRoleBoxSettingDialog() {
    $("#DialogUserOperatorRoleBoxSettings").dialog("open");
    $("#DialogUserOperatorRoleBoxSettings").html("<div class='loading-32'></div>");
    $("#DialogUserOperatorRoleBoxSettings").load(RQ_URL + "/Admin/UserBoxSettings/GetUserOperatorRoleBoxSettings", function () {
        $("#DialogUserOperatorRoleBoxSettings").dialog("close");
        $("#DialogUserOperatorRoleBoxSettings").dialog("open");
    });
}

function addNewUserSimpleRoleBoxField(id) {
    $.ajax({
        url: RQ_URL + "/Admin/UserBoxSettings/AddUserSimpleRole",
        type: "POST",
        data: JSON.stringify({
            id: id
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            $("#UserSimpleRoleBoxSettings").append(g);
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function addNewUserOperatorRoleBoxField(id) {
    $.ajax({
        url: RQ_URL + "/Admin/UserBoxSettings/AddUserOperatorRole",
        type: "POST",
        data: JSON.stringify({
            id: id
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            $("#UserOperatorRoleBoxSettings").append(g);
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}